<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2010 YANMAH2 project
//This program is freesoftware. you can redistribute it and/or modify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php defined("HELLO") or exit(); ?>
<?php
$entry_body = $val['text'];
if ($use_purifier == 'yes'){
	require_once 'HTMLPurifier.auto.php';
	$config = HTMLPurifier_Config::createDefault();
	$config->set('Cache.SerializerPath', $purifier_tmp_dir);
	$config->set('AutoFormat.Linkify', 'true');
	$config->set('HTML.SafeObject', 'false');
}
//エスケープ処理
if ($use_purifier != 'yes'){
	$entry_body = htmlspecialchars($entry_body, ENT_QUOTES);
}
if ($use_purifier == 'yes'){
	if (mb_ereg_match("^{$http_url_regexp}$", $val["keyword"])){
//		var_dump($val['keyword']);
// 		var_dump($entry_body);
		$entry_body = str_replace("{$val['keyword']}=", "{$val['keyword']} ", $entry_body);
//		var_dump($entry_body);
	}
	if (mb_ereg_match(".*{$http_host_regexp}{$http_path_regexp}.*", $entry_body)){
		$entry_body = preg_replace("/({$http_url_regexp}){1}/u", " \${1} ", $entry_body);
// 		var_dump($entry_body);
	}
// 	$entry_body = urldecode($entry_body);
//	var_dump($entry_body);
}
$entry_body = preg_replace("/(\r\n)|(\n)|(\r)/u","\n", $entry_body);
$entry_body = preg_replace("/(\n)+/u", "\n", $entry_body);
$entry_body = preg_replace("/\n$/u", "", $entry_body);
//$entry_body = $entry_body . "\n";
//echo htmlspecialchars(var_dump($entry_body));
//引用記法
$entry_body = preg_replace("/(&gt;&gt;\n)(.+)(&lt;&lt;)/us", "<blockquote>\${2}</blockquote>", $entry_body);
$entry_body = preg_replace("/(>>\n)(.+)(<<)/us", "<blockquote>\${2}</blockquote>", $entry_body);
//
$entry_body = nl2br($entry_body);
		//<br /> だけの行を削除
$entry_body = preg_replace("/^<br \/>$/um","",$entry_body);
//文字数制限
if ($entry_processor_mode == "entries"){
	if (strlen(bin2hex($entry_body)) / 2 > $entry_limit + ($entry_limit / 10)){
		$entry_body_temp = explode("\n", $entry_body);
		//var_dump($entry_body_temp);
		if (strlen(bin2hex($entry_body_temp[0])) / 2 > $entry_limit){
			if (count($entry_body_temp) > 2){
				$entry_body = preg_replace("/<br \/>$/us", "", $entry_body_temp[0]) . " <a href=\"./entry.php?entry={$val["id"]}&amp;user={$val["user"]["id"]}&amp;keyword=" . rawurlencode($val['keyword']) . "\" class=\"see-more\">（…）</a>";
			}	elseif (preg_match("/({$http_url_regexp})|(\[\[[^\]]+\]\])|(id:[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1})/u", $entry_body_temp[0]) != 1){
					$entry_body = mb_substr($entry_body_temp[0], 0, $entry_limit / 3, "UTF-8") . " <a href=\"./entry.php?entry={$val["id"]}&amp;user={$val["user"]["id"]}&amp;keyword=" . rawurlencode($val['keyword']) . "\" class=\"see-more\">（…）</a>";
			}	else {
					$entry_body = preg_replace("/<br \/>$/us", "", $entry_body_temp[0]);
				}
		}	else {
				$part = 1;
				$entry_body_temp2 = implode("\n",array_slice($entry_body_temp, 0, $part));
				while (count($entry_body_temp) >= $part + 1){
					if (strlen(bin2hex($entry_body_temp2)) / 2 >= $entry_limit){
						if (count($entry_body_temp) == 2){
							$entry_body = preg_replace("/<br \/>$/us", "", $entry_body_temp2);
							//var_dump($part);
							$part = $part + 1;
							break 1;
						}	else {
							$entry_body = preg_replace("/<br \/>$/us", "", $entry_body_temp2) . " <a href=\"./entry.php?entry={$val["id"]}&amp;user={$val["user"]["id"]}&amp;keyword=" . rawurlencode($val['keyword']) . "\" class=\"see-more\">（…）</a>";
							//var_dump($part);
							$part = $part + 1;
							break 1;
							}
					}	else {
							$part = $part + 1;
							$entry_body_temp2 = implode("\n",array_slice($entry_body_temp, 0, $part));
						}
				}
			}
	}
}
//var_dump($entry_body);
//本文中の id 記法をリンクにする。
// 	var_dump($entry_body);
if (preg_match("/(.+)(id:{1})(.+)/u", $val["keyword"])){
//  var_dump($entry_body);
  $entry_body = mb_ereg_replace("^[^=]+=", "", $entry_body);
}
$entry_body = preg_replace('/(id:{1})([a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1})/u',"<a href=\"./entries.php?user=\${2}\" class=\"hatena-id\">\${1}\${2}</a>",$entry_body);
if (preg_match("/(.+)(id:{1})(.+)/u", $val["keyword"])){
  $entry_body = $val['keyword'] . "=" . $entry_body;
//  var_dump($entry_body);
}
// 	var_dump($entry_body);
//
if ($use_purifier == 'yes'){
//	var_dump($entry_body);
//	$entry_body = urldecode($entry_body);
//	$entry_body = htmlspecialchars_decode($entry_body, ENT_QUOTES);
	$purifi = new HTMLPurifier($config);
	$entry_body = $purifi->purify($entry_body);
//	var_dump($entry_body);
}
//はてなスター
if ($val["favorited"] != "0"){
	$show_star = "<span class=\"hatena-star\"><a href=\"http://s.hatena.ne.jp/mobile/entry?uri=" . rawurlencode("http://h.hatena.ne.jp/{$val["user"]["id"]}/{$val["id"]}") . "\">★{$val["favorited"]}</a></span>";
} else {
	$show_star = "";
	}
if ($_SESSION['auth'] === TRUE){
	$add_star = '<input type="submit" value="☆＋" title="add-star" class="add-star-button" style="vertical-align: middle;"><input type="hidden" name="star" value="add" /><input type="hidden" name="entry" value="' . $val['id'] . '" /><input type="hidden" name="return" value="' . $self_anchor_possibly_with_pagenum . '" /> ';
}	else {
	$add_star = '';
}
//キーワードの前処理
if ($_SESSION['auth'] === TRUE){
  $headend = "</form>";
} else {
  $headend = "<br />";
}
if (mb_ereg_match("^{$http_url_regexp}$", $val["keyword"]) && $use_purifier == 'yes'){
//	var_dump($entry_body);
	$entry_body = mb_ereg_replace("^( <a href=\"{$http_url_regexp}\">{$http_url_regexp}</a>)(.*)", '\1' . " {$add_star}{$show_star}</span>{$headend}\n<span class=\"entry-body\">\n" . '\2', $entry_body);
//	var_dump($entry_body);
} elseif (mb_ereg_match("^{$http_url_regexp}$",$val["keyword"]) && $use_purifier != 'yes'){
	$entry_body = str_replace("{$val["keyword"]}=", "{$val["keyword"]}</span>{$headend}\n<span class=\"entry-body\">\n", $entry_body);
} elseif (!isset($val['keyword'])){
	$entry_body = "</span>{$headend}\n<span class=\"entry-body\">\n" . $entry_body;
} elseif (mb_strpos($entry_body, "{$val["keyword"]}=") !== FALSE) {
	//var_dump($val["keyword"]);
	$entry_body = str_replace("{$val['keyword']}=","%KEYWORD%</span>{$headend}\n<span class=\"entry-body\">\n",$entry_body);
} elseif (preg_match("/^(id:{1})(.+)/u", $val["keyword"]) == 0) {
//	var_dump($entry_body);
	$entry_body = mb_ereg_replace('^[^=]+=', "%KEYWORD%</span>{$headend}\n<span class=\"entry-body\">\n",$entry_body);
}
//var_dump($entry_body);
//HTMLPurifier 使用時の画像の処理
if ($GET['image'] == 'on' || $_SESSION['image'] == 'on'){
//	echo '<pre>' . var_dump($entry_body) . '</pre>';
	if ($use_purifier == 'yes'){
		$entry_body = preg_replace("/(<a href=\")({$http_url_regexp}){1}(\.gif|\.jpg|\.jpeg|\.png|\.bmp){1}([^\"]*){1}(\"[^>]*>)([^<]+)(<\/a>)/ui", "<a href=\"{$mobile_gateway}\${2}\${3}\${4}\"><img src=\"{$mobile_gateway_for_images}\${2}\${3}\${4}\" style=\"max-width: 150px; max-height: 150px\" alt=\"\" /></a>", $entry_body);
	} /*else {
		$entry_body = preg_replace("/({$http_url_regexp}){1}(\.gif|\.jpg|\.jpeg|\.png|\.bmp){1}([^\"]*){1}/ui", "<a href=\"{$mobile_gateway}\${1}\${2}\${3}\"><img src=\"{$mobile_gateway_for_images}\${1}\${2}\${3}\"/></a>", $entry_body);
	}*/
//	var_dump($entry_body);
}
//本文中の URL の処理
if ($use_purifier != 'yes'){
	$entry_body = preg_replace("/({$http_host_regexp})({$http_path_regexp})/u","<a href=\"{$mobile_gateway}\${1}\${2}\" class=\"external-link\">[リンク(\${1})]</a>",$entry_body);
} elseif ($use_purifier == 'yes'){
// 	var_dump($entry_body);
	$entry_body = preg_replace("/(<a href=\")(http:\/\/[^f]+\.hatena\.[^\/]+\/{$http_path_regexp})(\">)({$http_url_regexp})(<\/a>)/u", "<a href=\"{$mobile_gateway}\${2}\" class=\"to-hatena\">\${4}</a>", $entry_body);
// 	var_dump($entry_body);
	$entry_body = preg_replace("/(<a href=\")({$http_host_regexp})({$http_path_regexp})(\">)({$http_url_regexp})(<\/a>)/u", "<a href=\"{$mobile_gateway}\${2}\${3}\" class=\"external-link\">[リンク(\${2})]</a>", $entry_body);
	$entry_body = preg_replace('/(<a[^>]*)(href="\/asin\/)([[:alnum:]]{1,256})("[^>]*>)/u', "<a href=\"./entries.php?keyword=asin%3A\${3}\" class=\"keyword\">", $entry_body);
}
//キーワードの処理
if (!isset($val['keyword'])){
	$entry_body = ' ' . $add_star . $show_star . $entry_body;
}
$entry_body = str_replace("%KEYWORD%","<a href=\"./entries.php?keyword=" . rawurlencode($val["keyword"]) . "\" class=\"keyword\">". htmlspecialchars($val["keyword"], ENT_QUOTES) . "</a> {$add_star}{$show_star}",$entry_body);

//本文中のキーワード記法の処理
if (preg_match("/\[\[.+class=\"hatena-id\".+\]\]/u", $entry_body)){
	//echo "debug";
	$entry_body = preg_replace("/(\[\[)([^\]]*)(<a[^>]*class=\"hatena-id\">)(id:{1}[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1})(<\/a>)([^\]]*)(\]\])/u","\${1}\${2}\${4}\${6}\${7}", $entry_body);
}
$entry_body = preg_replace("/(\[\[)([^\]]+)(\]\])/u","<a href=\"./entries.php?keyword=\${2}\" class=\"keyword\">\${2}</a>",$entry_body);
//本文中の画像の URL の処理（上の「本文中の URL の処理」がすでに行われているとして）
if ($GET['image'] != 'on' && $_SESSION['image'] != 'on'){
	$entry_body = preg_replace("/<a href=\"({$http_url_regexp})(\.gif|\.jpg|\.jpeg|\.png|\.bmp)([^\"]*){1}\"[^>]*>\[リンク\((.+)\)\]<\/a>/ui","<a href=\"\${1}\${2}\${3}\" class=\"external-link image-link\">[画像(\${4}...\${2})]</a>",$entry_body);
} else {
	if ($use_purifier != 'yes'){
//		var_dump($entry_body);
		$mgw = preg_quote($mobile_gateway, '/');
//		var_dump($mgw);
		$entry_body = preg_replace("/(<a href=\")({$mgw})({$http_url_regexp}){1}(\.gif|\.jpg|\.jpeg|\.png|\.bmp){1}([^\"]*){1}(\"[^>]*>)(\[リンク\(.+\)\])(<\/a>)/ui", "<a href=\"{$mobile_gateway}\${3}\${4}\${5}\"><img src=\"{$mobile_gateway_for_images}\${3}\${4}\${5}\" style=\"max-width: 150px; max-height: 150px\" alt=\"\" /></a>", $entry_body);
	}
}
//var_dump($entry_body);
//id キーワードの処理
if (preg_match('/^(id:{1})(.*)/u',$val["keyword"]) >= 1){
	$entry_body = "<a href=\"./entries.php?keyword=" . rawurlencode($val["keyword"]) . "\" class=\"keyword\">" . htmlspecialchars($val["keyword"], ENT_QUOTES) . "</a> {$add_star}{$show_star}</span>{$headend}\n<span class=\"entry-body\">\n{$entry_body}";
}
//var_dump($entry_body);
//Reply-to
if ($val["in_reply_to_status_id"] != ''){
	$entry_body = str_replace("<span class=\"entry-body\">\n","<span class=\"entry-body\">\n<span class=\"reply-to reply\"><a href=\"./entry.php?entry={$val["in_reply_to_status_id"]}&user={$val["in_reply_to_user_id"]}&amp;keyword=" . rawurlencode($val['keyword']) . "\" class=\"hatena-id\">［← " . $val["in_reply_to_user_id"] . " へ</a></span><br />\n",$entry_body);
}
//Reply-from
if (isset($reply_from)){
	unset($reply_from);
}
if (isset($in_reply)){
	unset($in_reply);
}
if (isset($val["replies"][0]["id"])){
	foreach($val["replies"] as $replies){
		$in_reply = $in_reply . " <a href=\"./entry.php?entry={$replies['id']}&user={$replies["user"]["id"]}&amp;keyword=" . rawurlencode($val['keyword']) . "\" class=\"hatena-id\">［← {$replies["user"]["id"]} から</a> ";
	}
	$reply_from = "<span class=\"reply-from reply\">{$in_reply}</span>";
}
//
if ($_SESSION['auth'] === TRUE && $entry_processor_mode != 'entry'){
	$replying = '<a href="./entry.php?entry=' . $val['id'] . '&amp;user=' . $val['user']['id'] . '&amp;keyword=' . rawurlencode($val['keyword']) . '" class="replying">Re</a> ';
}
//
$entry_body = $entry_body . "<br />\n";
//公式モバイル版における各エントリへのリンク URL 生成
//$refer_link = preg_replace("/({$http_host_regexp})({$http_path_regexp})/u","\${1}mobile/\${2}",$val["link"]);
$refer_link = 'http://h.hatena.ne.jp/mobile/' . $val['user']['id'] . '/' . $val['id'];
//タイムスタンプ
$unix_time = strtotime($val["created_at"]);
if (preg_match("/[0-2][0-9]:[0-9]{2}:[0-9]{2}/u", $val['keyword'])){
  $dating = date("y-n-j H:i:s", $unix_time);
} else {
  $dating = date("y-n-j H:i", $unix_time);
}
//<br /> だけの行を削除
$entry_body = preg_replace("/^<br \/>$/um","",$entry_body);
//表示
//		echo $val["replies"][0]["id"];
echo "<div class=\"entry\">";
if ($_SESSION['auth'] === TRUE) echo '<form method="post" action="">';
echo "<span class=\"entry-head\">";
if ($GET['image'] == 'on' || $_SESSION['image'] == 'on'){
	echo '<img src="' . $val['user']['profile_image_url'] . '" width="16" height="16" class="user-icon" style="vertical-align: middle;" alt="" /> ';
}
echo "<a href=\"./entries.php?user=";
echo $val["user"]["id"];
echo "\" class=\"hatena-id\">";
echo $val["user"]["id"];
echo '</a> ';
echo urldecode($entry_body);
echo "</span><span class=\"dating\">{$dating}</span> {$replying}{$reply_from} <a href=\"{$refer_link}\" class=\"to-original-link\">&nbsp;†&nbsp;</a>";
echo "</div><hr />\n";
?>
